<!doctype html>
<html lang="en">
  <head>
    <meta charset="utf-8" />
    <meta
      name="viewport"
      content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no"
    />
    <title>Story of how a 🐍 became a 🦀</title>

    <meta name="description" content="new sett GUI with Tauri" />
    <meta name="author" content="Christian Ribeaud, Jarosław Surkont" />
    <meta name="apple-mobile-web-app-capable" content="yes" />
    <meta
      name="apple-mobile-web-app-status-bar-style"
      content="black-translucent"
    />

    <meta name="viewport" content="width=device-width, initial-scale=1.0" />

    <title>reveal.js</title>

    <link rel="stylesheet" href="dist/reset.css" />
    <link rel="stylesheet" href="dist/reveal.css" />
    <link rel="stylesheet" href="dist/theme/white.css" />
    <link rel="stylesheet" href="css/custom.css" />
    <link rel="stylesheet" href="plugin/highlight/monokai.css" />
  </head>
  <body>
    <div class="reveal">
      <div class="slides">
        <section>
          <h2 style="margin-bottom: 100px">Story of how a 🐍 became a 🦀</h2>
          <p style="margin-bottom: 50px">
            titled by <strong>Simone Guzzi</strong> and presented by
            <strong>Christian Ribeaud</strong>
          </p>
          <p>
            <a
              href="https://biomedit.gitlab.io/presentations/new-sett-gui-with-tauri"
              >biomedit.gitlab.io/presentations/new-sett-gui-with-tauri</a
            >
          </p>
          <aside class="notes" data-markdown>
            <textarea data-template>
              - Disclaimer: I participated in the development of the new sett GUI. However I do not know all the edges. But enough I guess to make a presentation.
                If you have any questions I might not be able to answer from the top of my head, I will look it up them later.
            </textarea>
          </aside>
        </section>

        <section>
          <h2>Outline</h2>
          <ul>
            <li>Legacy sett 🎡</li>
            <li>Electron 🔋</li>
            <li>Tauri 🧬</li>
            <li>New sett 🎢</li>
            <li>References ℹ️</li>
          </ul>
        </section>

        <section>
          <h2>Legacy sett 🎡</h2>
          <ul>
            <li><a href="https://pypi.org/project/sett/">🐍</a></li>
            <li>Multiple (and non-obvious) installation process</li>
            <li>Manual update</li>
            <li>Problematic <a href="https://gnupg.org/">GnuPG</a> tooling</li>
            <li>
              <strong>PyQt</strong> feeling like <strong>Swing</strong>:<br />
              <img src="img/old_pinup_lady.jpg" style="height: 250px" />
            </li>
          </ul>
          <aside class="notes" data-markdown>
            <textarea data-template>
              - sett - _Secure Encrypted Transfer Tool_
              - Brief history of **sett**:
                - Developped by **BioMedIT** as desktop application for data transfers
                - Over time maintenance became a nightmare
                - We started to replace parts of the code with functionalities written in **Rust** but integrated via **Python** bindings
                - After a while we had completely rewritten the **CLI** in **Rust** but users were requesting a **GUI**
            </textarea>
          </aside>
        </section>

        <section>
          <h2>Electron 🔋</h2>
          <ul>
            <li><a href="https://www.electronjs.org/">https://www.electronjs.org/</a></li>
            <li>
              For many years the <em>de facto</em> cross-platform framework
              for building desktop apps.
            </li>
            <li>
              Uses the <a href="https://www.chromium.org/">Chromium</a> rendering engine to render
              web pages, and the <strong>Node.js</strong> runtime to execute
              code.
            </li>
            <li>
              Even a super simple <em>Hello, World!</em> app can be a huge
              size (over <em>120 MB</em>)
            </li>
          </ul>
          <aside class="notes" data-markdown>
            <textarea data-template>
              - <strong>VS Code</strong>, <strong>Slack</strong>, <strong>Twitch</strong>, and many other popular desktop applications are built using Electron.
              - App backend is written in <strong>JavaScript</strong> because <strong>Electron</strong> uses <strong>Node.js</strong> as its runtime.
            </textarea>
          </aside>
        </section>

        <section>
          <section>
            <h2>Tauri 🧬 (in a nutshell)</h2>
            <ul>
              <li>
                <strong>Secure</strong> foundation for building apps for all
                major desktop platforms
              </li>
              <li>
                <strong>Smaller</strong> bundle size by using the system's
                native webview
              </li>
              <li>Frontend framework <strong>agnostic</strong></li>
              <li>
                Extensive
                <a href="https://tauri.app/v1/api/config">configuration</a> for
                setting up cross-platform or platform specific features
              </li>
            </ul>
            <aside class="notes" data-markdown>
              <textarea data-template>
                - <strong>Tauri</strong> only has experimental support for <strong>iOS</strong> and <strong>Android</strong>.
              </textarea>
            </aside>
          </section>
          
          <section>
            <h2>Security</h2>
            <ul>
              <li><strong>Tauri</strong> uses a memory-safe language on the <em>backend</em></li>
              <li><strong>Tauri</strong> has many <a href="https://tauri.app/about/security">security</a> features built-in by default</li>
              <li>You can explicitly enable or disable certain <a href="https://tauri.app/v1/api/js/">APIs</a>.
                Or you have to explicitly expose the <strong>Rust</strong> functions.</li>
            </ul>
            <aside class="notes" data-markdown>
              <textarea data-template>
              - Decompilation is difficult
              - Allowing API
              </textarea>
            </aside>
          </section>

          <section>
            <h2>Rendering</h2>
            <ul>
              <li><strong>Tauri</strong> uses the system webview: <a href="https://developer.microsoft.com/en-us/microsoft-edge/webview2/">Edge Webview2 (Chromium)</a>
                on <strong>Windows</strong>, <a href="https://webkitgtk.org/">WebKitGTK</a> on <strong>Linux</strong> and
                <a href="https://webkit.org/">WebKit</a> on <strong>macOS</strong>.</li>
              <li><strong>Smaller</strong> bundle size by using the system's native webview</li>
            </ul>
            <aside class="notes" data-markdown>
              <textarea data-template>
                - If you are a web developer you know that <strong>Safari</strong> (Based on WebKit) is always behind a step from every web browser.
                - Only <strong>Svelte</strong>, <strong>SvelteKit</strong> wouldn't work with <strong>Tauri</strong> because of the server side rendering.
              </textarea>
            </aside>
          </section>

          <section>
            <h2>Development</h2>
            <ul>
              <li>Frontend framework <strong>agnostic</strong></li>
              <li>Hot reload</li>
              <li>App for all platforms. Cross-compilation is not possible though.</li>
              <li><code>cargo tauri dev</code> to start <strong>Tauri</strong> development</li>
              <li><strong>Node</strong> server only for development</li>
            </ul>
            <aside class="notes" data-markdown>
              <textarea data-template>
                - <strong>React</strong>, <strong>Vue</strong>, <strong>Angular</strong>, <strong>Svelte</strong> or vanilla <strong>HTML</strong> and <strong>JavaScript</strong> can be used.
                - And here comes the best: <strong>Tauri</strong> is compatible with every web framework on earth. 
                  It just expects a localhost url or a folder where all your bundled code lives.
                - Keep the number of dependencies as low as possible
                - Do as much as possible of the work in the <strong>Rust</strong> code, and only pass the very minimum to the <em>frontend</em>.
              </textarea>
            </aside>
          </section>


          <section>
            <h2>Distribution</h2>
            <img src="https://imgs.xkcd.com/comics/update_2x.png" style="height: 200px" /><br />
            <ul>
              <li><a href="https://vitejs.dev/">Vite</a> compiles HTML/CSS/TypeScript into <em>static</em> assets</li>
              <li><a href="https://tauri.app/v1/guides/distribution/updater">Updater</a> which requests <a href="https://gitlab.com/biomedit/sett-rs/-/snippets/3639261">this</a> configuration page.</li>
              <li>Support for code signing. Prefer to go with a signing solution which supports <strong>CI</strong>/<strong>CD</strong></li>
            </ul>
            <aside class="notes" data-markdown>
              <textarea data-template>
                - Code signing certificates provided by <strong>Apple</strong> for <strong>Mac</strong> binaries
                and by <a href="https://www.certum.eu/">Certum</a> for <strong>Microsoft</strong> ones.
              </textarea>
            </aside>
          </section>
        </section>

        <section>
          <section>
            <h2>New sett 🎢</h2>
            <ul>
              <li>🦀</li>
              <li>
                One binary installation for <strong>mac</strong>,
                <strong>win</strong> and <strong>linux</strong>
              </li>
              <li>
                Built-in updater (provided out-of-the-box by
                <strong>Tauri</strong>)
              </li>
              <li>
                Modern frontent technology (<strong>Svelte</strong>):<br />
                <img src="img/new_pinup_lady.jpg" style="height: 250px" />
              </li>
            </ul>
            <aside class="notes" data-markdown>
              <textarea data-template>
                - https://gitlab.com/biomedit/sett-rs/-/snippets (for the updater)
                - https://gitlab.com/biomedit/sett-rs/-/packages/ (for the releases)
              </textarea>
            </aside>
          </section>
          <section>
            <h2>Sequoia PGP</h2>
            <ul>
              <li>Modular <strong>OpenPGP</strong> implementation in <strong>Rust</strong></li>
              <li><a href="https://sequoia-pgp.org/">https://sequoia-pgp.org/</a>. <b>Neal</b> made about a presentation about the whole toolchain.
              More could be found on the <a href="https://sequoia-pgp.org/blog/2024/04/25/202404-community/">community</a> page.</li>
              <li>Complete replacement of <a href="https://www.gnupg.org/">GnuPG</a> tooling</li>
            </ul>
          </section>
          <section>
            <h2>Compression</h2>
            <ul>
              <li><a href="https://facebook.github.io/zstd/">Zstandard</a></li>
              <li><strong>GZIP</strong> compression</li>
            </ul>
          </section>
          <section>
            <h2>Demo</h2>
            <ul>
              <li><a href="https://gitlab.com/biomedit/sett-rs">Monorepo</a> with <em>main</em> library, <strong>CLI</strong>, <strong>GUI</strong> and <strong>Python</strong> bindings</li>
              <li><a href="https://biomedit.gitlab.io/docs/sett/download_sett/">Download</a> page</li>
              <li><strong>GUI</strong> demo with <em>encrypt</em>, <em>transfer</em>, <em>decrypt</em></li>
            </ul>
            <aside class="notes" data-markdown>
              <textarea data-template>
                - We are happy with our decision, it was a good move
              </textarea>
            </aside>
          </section>
        </section>

        <section
          data-background-image="img/andermatt.jpg"
          data-background-size="cover"
          class="top"
        >
          <p style="font-size: 150%; color: black; font-weight: 800">
            That's all for now 🚠
          </p>
          <p style="font-size: 50%; color: black; font-weight: 800">
            <em>Andermatt, 2024</em>
          </p>
          <p class="r-stretch"></p>
        </section>

        <section>
          <h3>References ℹ️</h3>
          <ul>
            <li>
              <a href="https://gitlab.com/biomedit/sett-rs">sett-rs 🦀</a>
            </li>
            <li><a href="https://tauri.app/">Tauri</a></li>
          </ul>
          <aside class="notes" data-markdown>
            <textarea data-template>
              - **v2** is under development and is already in *beta*.
            </textarea>
          </aside>
        </section>
      </div>
    </div>
    <script src="dist/reveal.js"></script>
    <script src="plugin/notes/notes.js"></script>
    <script src="plugin/markdown/markdown.js"></script>
    <script src="plugin/highlight/highlight.js"></script>
    <script>
      Reveal.initialize({
        hash: true,
        slideNumber: "c/t",
        plugins: [RevealMarkdown, RevealHighlight, RevealNotes],
      });
    </script>
  </body>
</html>
